﻿using GpsCardGatewayPosition.Model.Cache;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace GpsCardGatewayPosition.Common.Extract
{
    public class LonLat
    {
        public decimal GaodeLon { get; set; }
        public decimal GaodeLat { get; set; }
        public string Address { get; set; } = default!;
    }

    public class Backups
    {
        /// <summary>
        /// 如果wifi上报的主mac包含如下信息，则该wifi丢弃
        /// 包括以下厂商信息：
        /// Realme
        /// OnePlus
        /// vivo Mobile
        /// OPPO MOBILE
        /// China Mobile IOT
        /// China Mobile Group Device
        /// China Mobile (Hangzhou) Information Technology
        /// SICHUAN TIANYI COMHEART TELECOM CO.,LTD
        /// </summary>
        public static List<string> Mmacs = new()
        {
            "1802AE","0C20D3","08B3AF","DC31D1","E013B5","88F7BF","4CC00A","9CE82B","3CA616","F4B7B3",
            "C4ABB2","1CDA27","6091F3","BC2F3D","9CA5C0","C46699","207454","A022DE","F8E7A0","2CFFEE",
            "087F98","FCBE7B","B40FB3","283166","70B7AA","946372","B80716","70D923","F470AB","3CB6B7",
            "3CA348","E45AA2","609E64","001981","18E777","6CD94C","642C0F","30AFCE","309435","488764",
            "5C1CB9","7047E9","90ADF7","70788B","0823B2","F01B6C","20311C","08FA79","808A8B","449EF9",
            "EC7D11","386EA2","5419C8","9CFBD5","18E29F","886AB1","E0DDC0","28FAA0","ECDF3A","F42981",
            "64B64A","D8A315","10BC97","D4BBC8","90C54A","20F77C","3CA581","34E911","94147A","205D47",
            "000A0E","DC1AC5","101212","FC1A11","10F681","0002D1","3C86D1","6C24A6","98C8B8","540E2D",
            "708F47","6C1ED7","2479F3","C4E39F","D81EDD","C02E25","58C6F0","2CA9F0","B4CB57","18D717",
            "E4C483","084ACF","D4503F","38295A","E44790","C8F230","8C0EE3","B0AA36","A09347","E8BBA8",
            "B8C9B5","F06728","B0B5C3","E433AE","F4D620","44AEAB","A4F05E","846FCE","5029F5","1CC3EB",
            "7836CC","EC51BC","F079E8","3CF591","602101","ECF342","4C1A3D","CC2D83","DC6DCD","BC3AEA",
            "A43D78","FCA5D0","8803E9","6CD71F","885A06","2C5D34","D467D3","A41232","9C0CDF","14C697",
            "7C6B9C","4466FC","503CEA","F06D78","1CDDEA","88D50C","1C48CE","6C5C14","1C77F6","20826A",
            "60D4E9","9454CE","388ABE","5C666C","C4E1A1","70DDA8","4C6F9C","4883B4","D41A3F","986F60",
            "C09F05","440444","18D0C5","9CF531","14472D","1C0219","C440F6","489507","B8C74A","1C427D",
            "587A6A","DC5583","94D029","308454","4C189A","B83765","EC01EE","A81B5A","2C5BB8","A4C939",
            "9C5F5A","B4A5AC","C4FE5B","2064CB","5CCD7C","38BC1A","683E34","90F052","B40B44","34D712",
            "D028BA","5C17CF","48216C","1C4176","58C876","A091A2","B03055","AC5AEE","705E55","CCF0FD",
            "A0950C","C0D0FF","44C874","1869DA","C43306","C098DA","44E6B0","1C25E1","688B0F","6458AD",
            "AC5474","E42D7B","047E23","D47EE4","B05365","64F88A","A09B12","48216C","B03055","F848FD",
            "78C313","74ADB7","90473C","103D3E","AC710C","B4D0A9","7089CC","CC5CDE","0C14D2","8C53D2",
            "24615A","3CE3E7","508CF5","E0456D","4062EA","00CFC0","3C574F","1479F3","E4C0CC","C01692",
            "00E22C","E0E0C2","20968A","8C1850","B45459","A84122","2400FA","2823F5","F010AB","B4BA12",
            "1012B4","F4323D","B0AAD2","48A73C","18AACA","B4CFE0",
        };


        /// <summary>
        /// 待纠正地址列表
        /// </summary>
        public static List<AddressFilterModel> Addresses = new List<AddressFilterModel>
        {
            //"北山森林公园"  //对应 LonLatDict的"0"
            new AddressFilterModel{ Address="北山森林公园", City="大兴安岭"}
        };

        /// <summary>
        /// 对应待纠正地址列表的纠正后数据
        /// </summary>
        public static Dictionary<string, LonLat> LonLatDict = new Dictionary<string, LonLat>
        {
            {"0",new LonLat{ GaodeLon=124.153685m,GaodeLat=50.428302m,Address="启明路大兴安岭实验中学东校区"} }
        };
    }
}
